/* swab.c: (C)TOYODA Eizi, 1996
 * byte order convertor for 4byte unit data
 */

#include <stdio.h>

#define	eputs(s)	(void)fputs((s), stderr)

FILE	*input, *output;

	int
swap()
{
	char	buf[4], obuf[4];
	int	r;
	r = fread(buf, 1, 4, input);
	if (r == 0)
		return 1;	/* error(can't detect) or End Of File */
	if (r != 4) {
		eputs("Warning: input format error or text mode\n");
		return 3;
	}
	obuf[0] = buf[3];
	obuf[1] = buf[2];
	obuf[2] = buf[1];
	obuf[3] = buf[0];
	r = fwrite(obuf, 1, 4, output);
	if (r != 4) {
		eputs("cannot write or disk full\n");
		return 2;
	}
	return 0;
}

	void
help(prog)
	char	*prog;
{
	eputs(prog);
	eputs(": (C)TOYODA Eizi, 1996\n");
	eputs("usage: ");
	eputs(prog);
	eputs(" [input output]\n");
}

	int
loop(prog)
	char	*prog;
{
	int	r;
	if (isatty(fileno(input)) || isatty(fileno(output))) {
		eputs(prog);
		eputs(": terminal I/O not assumed\n");
		return 1;
	}
	while ((r = swap()) == 0)
		;
	return r-1;
}

	int
main(argc, argv)
	int	argc;
	char	*argv[];
{
	int	r;
	if (argc < 2) {
		/*
		 * case with no argument - most MS-DOS environment
		 * initially sets stdin and stdout text mode
		 */
#ifdef __MSDOS__
		help(argv[0]);
		r = 1;
#else
		input = stdin;
		output = stdout;
		r = loop(argv[0]);
#endif
	} else if (argc == 3) {
		input = fopen(argv[1], "rb");
		if (input == NULL) {
			eputs(argv[1]);
			eputs(": cannot open\n");
			return 2;
		}
		output = fopen(argv[2], "wb");
		if (output == NULL) {
			eputs(argv[2]);
			eputs(": cannot open\n");
			return 2;
		}
		r = loop(argv[0]);
		(void)fclose(input);
		(void)fclose(output);
	} else {
		/* wrong argument number */
		help(argv[0]);
		r = 1;
	}
	return r;
}

/* EOF */
